﻿@inherits LayoutComponentBase
@inject NavigationManager NavigationManager
@inject CustomAuthenticationStateProvider CustomAuthStateProvider
@inject HttpClient Http

<MudThemeProvider @ref="_mudThemeProvider" @bind-IsDarkMode="_isDarkMode" Theme="MyCustomTheme" />
<MudDialogProvider />
<MudSnackbarProvider />

<MudLayout>
	@if (!noUsers)
	{
		<MudAppBar>
			<MudIconButton Icon="@Icons.Material.Filled.Menu" Color="Color.Secondary" Edge="Edge.Start" OnClick="DrawerToggle" />
			<MudBadge Color="Color.Primary" Overlap="true" Class="mx-6 my-4" Visible="@_youHaveMail">
				<MudIcon Icon="@Icons.Material.Filled.Email" Color="Color.Default" />
			</MudBadge>

			@if (CustomAuthStateProvider.responseModel != null)
			{
				<MudSpacer />
				<MudButton OnClick="Logout" Variant=Variant.Outlined Color=Color.Secondary>Logout</MudButton>
			}
		</MudAppBar>
		<MudDrawer @bind-Open="_drawerOpen">
			<NavMenu />
			<MudSwitch @bind-Checked="_isDarkMode" Color="Color.Primary" Class="ma-4" T="bool" Label="Toggle Light/Dark Mode" />
		</MudDrawer>
		<AuthorizeView>
			<Authorized>
				<MudMainContent>
					@if (CustomAuthStateProvider.responseModel != null)
					{
						@Body
					}
				</MudMainContent>
			</Authorized>
			<NotAuthorized>
				<MudMainContent>
					<p>You are not authorized to view this page. Please <a href="/login">log in</a>.</p>
				</MudMainContent>
			</NotAuthorized>
		</AuthorizeView>
	}
	else
	{
		@Body
	}
</MudLayout>

@code {
	bool _drawerOpen = true;
	bool _youHaveMail = true;
	DateTime date = DateTime.Now;
	private bool _isDarkMode;
	private MudThemeProvider _mudThemeProvider;
	private List<GetUserModel> users;
	private bool noUsers = false;

	void DrawerToggle()
	{
		_drawerOpen = !_drawerOpen;
	}

	protected override async Task OnAfterRenderAsync(bool firstRender)
	{
		if (firstRender)
		{
			_isDarkMode = await _mudThemeProvider.GetSystemPreference();
			StateHasChanged();

			var authState = await CustomAuthStateProvider.GetAuthenticationStateAsync();
			var user = authState.User;
			if (!authState.User.Identity.IsAuthenticated)
			{
				users = await Http.GetFromJsonAsync<List<GetUserModel>>("/api/Users");
				if (users.Count() == 0)
				{
					noUsers = true;
					StateHasChanged();
				}
				else
				{
					NavigationManager.NavigateTo("/login");
				}
			}
			else
			{
				StateHasChanged();
			}
		}
	}

	private async Task Logout()
	{
		await CustomAuthStateProvider.MarkUserAsLoggedOut();
		NavigationManager.NavigateTo("/login");
	}

	MudTheme MyCustomTheme = new MudTheme()
		{
			Palette = new PaletteLight()
			{
				Primary = Colors.Blue.Darken4,
				Secondary = Colors.Grey.Lighten4,
			},
			PaletteDark = new PaletteDark()
			{
				Primary = Colors.Red.Lighten1,
				Secondary = Colors.Grey.Lighten5,
				AppbarBackground = Colors.Grey.Darken4,
			},
			LayoutProperties = new LayoutProperties()
			{
				DrawerWidthLeft = "260px",
				DrawerWidthRight = "300px"
			}
		};
}
